#!/usr/bin/python
# -*- coding: utf-8 -*-

"""
helper class for making a SAT frontend
Copyright (C) 2009, 2010, 2011, 2012  Jérôme Poisson (goffi@goffi.org)

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
"""

from logging import debug, info, error
from sat.tools.jid  import JID


class QuickContactList():
    """This class manage the visual representation of contacts"""

    def __init__(self, CM):
        """
        @param CM: instance of QuickContactManagement
        """
        debug(_("Contact List init"))
        self.CM = CM

    def __contains__(self, jid):
        raise NotImplementedError
    
    def clear_contacts(self, jid):
        """Clear all the contact list"""
        raise NotImplementedError
    
    def replace(self, jid, groups=None):
        """add a contact to the list if doesn't exist, else update it"""
        raise NotImplementedError
    
    def disconnect(self, jid):
        """mark a contact disconnected"""
        raise NotImplementedError
    
    def remove(self, jid):
        """remove a contact from the list"""
        raise NotImplementedError
    
    def add(self, jid, param_groups=None):
        """add a contact to the list"""
        raise NotImplementedError
